#ifndef _fonctions_h
#define _fonctions_h

#include <cstdlib>
#include <cmath>
#include <vector>

/* auxiliaire x^n */
double puiss(double x,int n);

/* Homma-Saltelli: (loi uniforme sur [-pi,pi]) */
std::vector<double> hs(std::vector<double>& X, long S);

/* modele a deux dimensions de la fonction precedente */
std::vector<double> hs2(std::vector<double>& X, long S);

/* fonction g de Sobol: (produit des phi_i(t)) */
std::vector<double> g(std::vector<double>& X, long S);

/* fonction chameau (cf. Scheidt 2006) */
std::vector<double> cham(std::vector<double>& X, long S);

/* fonction chameau decale (cf. Scheidt 2006) */
std::vector<double> chamdec(std::vector<double>& X, long S);

/* fonction non reguliere 2 (cf. Scheidt 2006) */
std::vector<double> scheidt2(std::vector<double>& X, long S);

/* fonction dosimetre_cuivre (cf. Beretz et al. 2003) */
std::vector<double> dosiCu(std::vector<double>& X, long S);

/* fonction dosimetre_U238 (cf. Beretz et al. 2003) */
std::vector<double> dosiU(std::vector<double>& X, long S);

#endif
