#include "moyMinMax.h"

/* elevation a une puissance entiere */
long puiss(long a, int b) { 
	if (b<=0) return 1;
	int tmp=puiss(a,b/2); 
	if (b&1) return a*tmp*tmp;
	else return tmp*tmp;
}

/* calculs des min, max, moy et ecarts-type */
/* a) pour un pointeur "malloc" */
double mean(double* v, int i, long R) {
	double res=0;
	for (long j=R-1; j>=0; j--) res+=v[i*R+j];
	return res/R;
}
double mean(double* v, int i, int ip, int dim, long R) {
	double res=0;
	for (long j=R-1; j>=0; j--) res+=v[i*dim*R+ip*R+j];
	return res/R;
}
double min(double* v, long R) {
	double res=v[R-1];
	for (long j=R-2; j>=0; j--)
		if (v[j]<res) res=v[j];
	return res;
}
double min(double* v, int i, long R) {
	double res=v[(i+1)*R-1];
	for (long j=R-2; j>=0; j--)
		if (v[i*R+j]<res) res=v[i*R+j];
	return res;
}
double min(double* v, int i, int ip, int dim, long R) {
	double res=v[i*dim*R+(ip+1)*R-1];
	for (long j=R-2; j>=0; j--)
		if (v[i*dim*R+ip*R+j]<res) res=v[i*dim*R+ip*R+j];
	return res;
}
double max(double* v, long R) {
	double res=v[R-1];
	for (long j=R-2; j>=0; j--)
		if (v[j]>res) res=v[j];
	return res;
}
double max(double* v, int i, long R) {
	double res=v[(i+1)*R-1];
	for (long j=R-2; j>=0; j--)
		if (v[i*R+j]>res) res=v[i*R+j];
	return res;
}
double max(double* v, int i, int ip, int dim, long R) {
	double res=v[i*dim*R+(ip+1)*R-1];
	for (long j=R-2; j>=0; j--)
		if (v[i*dim*R+ip*R+j]>res) res=v[i*dim*R+ip*R+j];
	return res;
}
double sig(double* v, int i, long R) {
	double res=0,moy=0;
	for (long j=R-1; j>=0; j--) {
		res+=v[i*R+j]*v[i*R+j];
		moy+=v[i*R+j];
	}
	moy/=R;
	res=res/R-moy*moy;
	return sqrt(res);
}
double sig(double* v, int i, int ip, int dim, long R) {
	double res=0,moy=0;
	for (long j=R-1; j>=0; j--) {
		res+=v[i*dim*R+ip*R+j]*v[i*dim*R+ip*R+j];
		moy+=v[i*dim*R+ip*R+j];
	}
	moy/=R;
	res=res/R-moy*moy;
	return sqrt(res);
}

/* b) pour un pointeur "vector" */
double min(std::vector<double>& v, long R) {
	double res=v[R-1];
	for (long j=R-2; j>=0; j--)
		if (v[j]<res) res=v[j];
	return res;
}
double min(std::vector<double>& v, int i, long R) {
	double res=v[(i+1)*R-1];
	for (long j=R-2; j>=0; j--)
		if (v[i*R+j]<res) res=v[i*R+j];
	return res;
}
double min(std::vector<double>& v, int i, int ip, int dim, long R) {
	double res=v[i*dim*R+(ip+1)*R-1];
	for (long j=R-2; j>=0; j--)	
		if (v[i*dim*R+ip*R+j]<res) res=v[i*dim*R+ip*R+j];
	return res;
}
double max(std::vector<double>& v, long R) {
	double res=v[R-1];
	for (long j=R-2; j>=0; j--)
		if (v[j]>res) res=v[j];
	return res;
}
double max(std::vector<double>& v, int i, long R) {
	double res=v[(i+1)*R-1];
	for (long j=R-2; j>=0; j--)
		if (v[i*R+j]>res) res=v[i*R+j];
	return res;
}
double max(std::vector<double>& v, int i, int ip, int dim, long R) {
	double res=v[i*dim*R+(ip+1)*R-1];
	for (long j=R-2; j>=0; j--)
		if (v[i*dim*R+ip*R+j]>res) res=v[i*dim*R+ip*R+j];
	return res;
}
