#Ishigami: (loi uniforme sur [-pi,pi])
hs<-function(x) {
	return(sin(x[,1])+7*(sin(x[,2]))^2+0.1*x[,3]^4*sin(x[,1]))
}

#modele a deux dimensions de la fonction precedente
hs2<-function(x) {
	res<-array(dim=c(NROW(x),2))
	res[,1]<-sin(x[,1])+7*(sin(x[,2]))^2+0.1*x[,3]^4*sin(x[,1])
	res[,2]<-sin(x[,2])+7*(sin(x[,1]))^2+0.1*x[,3]^4*sin(x[,2])
	return(res)
}

#fonction g de Sobol: (produit des phi_i(t))
g<-function(x) {
	a<-rep(3,8)
	a[1]<-0
	a[2]<-0
	res<-1
	for (i in 1:NCOL(x))
		res<-res*(abs(4*x[,i]-2)+a[i])/(1+a[i])
	return(res)
}

# fonction chameau (cf. Scheidt 2006)
cham <- function(x){
  return(4*x[,1]^4-21/10*x[,1]^4+1/3*x[,1]^6+x[,1]*x[,2]-4*x[,2]^2+4*x[,2]^4)
}

# fonction chameau decale (cf. Scheidt 2006)
chamdec <- function(x){
  return(81*x[,1]^4-21/10*(3*x[,1])^4+1/3*(3*x[,1])^6+9*x[,1]*x[,2]-36*x[,2]^2+81*x[,2]^4)
}

# fonction non reguliere 2 (cf. Scheidt 2006)
scheidt2 <- function(x){
  return(0.2*exp(x[,1]-3)+2.2*abs(x[,2])+1.3*x[,2]^6-2*x[,2]^2-0.5*x[,2]^4-0.5*x[,1]^4+2.5*x[,1]^2+0.7*x[,1]^3+3/((8*x[,1]-2)^2+(5*x[,2]-3)^2+1)+sin(5*x[,1])*cos(3*x[,1]^2))
}

# fonction dosimetre cuivre (cf. Beretz et al. 2003)
dosiCu <- function(x){
  return(5.8044e11+9.9320e10*x[,1]-3.6102e11*x[,2]+8.2874e10*x[,2]^2-8.5334e9*x[,2]^3+3.4654e8*x[,2]^4-9.9719e9*x[,1]*x[,2])
}
